﻿<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8">
  <title>Prohlížeč obrázků</title>
  <style type="text/css">
  td, th {
    padding: 10px;
  }
  </style>
</head>
<body>

<?php

$action = htmlspecialchars($_GET[action]);

switch ($action) {
case "list_dir":
  $dir = htmlspecialchars(urldecode($_GET[dir]));
  if(file_exists($dir)) list_dir($dir);
	break;

case "display_image":
  $image = htmlspecialchars(urldecode($_GET[image]));
  $adr = htmlspecialchars(urldecode($_GET[adr]));
  $poradi = htmlspecialchars(urldecode($_GET[poradi]));
  $celkem = htmlspecialchars(urldecode($_GET[celkem]));
  $width = htmlspecialchars(urldecode($_GET[width]));
  $height = htmlspecialchars(urldecode($_GET[height]));
  
  if(file_exists($image)) {
    if($width != "" && $height != "") display_image($image, $adr, $poradi, $celkem, $width, $height);
    else display_image($image, $adr, $poradi, $celkem);
  }
	break;

default:
  list_dir(".");
	break;
}

function endsWith($str, $sub) {
  return (substr($str, strlen($str) - strlen($sub)) == $sub);
}

function isPict($filename) {
  return (endsWith($filename, ".jpg") || endsWith($filename, ".jpeg"));
}

function get_dirs($adr = ".") {
  $dir = @opendir($adr);
  if(!$dir) return;
  
  for($i = 0; ($soubor = readdir($dir)) !== false; $i++) {
    if($i > 0 && is_dir($adr."/".$soubor)) $files[$i] = $soubor;
  }
  closedir($dir);
  if(!is_null($files)) sort($files);
  return $files;
}

function get_picts($adr = ".") {
  $dir = @opendir($adr);
  if(!$dir) return;

  for($i = 0; ($soubor = readdir($dir)) !== false; $i++) {
    $path = $adr . "/" . $soubor;
    if(is_file($path) && isPict($path)) $files[$i] = $soubor;
  }
  closedir($dir);
  if(!is_null($files)) sort($files);
  return $files;
}

function list_dir($adr = ".") {
  $dirs = get_dirs($adr);
  $files = get_picts($adr);
  
  echo "<table width=100%>";

  echo "<tr><th colspan=6><h2>";
  echo "Nacházíte se v adresáři: " . realpath($adr);
  echo "</h2><br><br></td></th>";
  
  echo "<tr>";
  echo "<th>Jméno</th>";
  echo "<th>Náhled</th>";
  echo "<th>Čas poslední změny</th>";
  echo "<th>Velikost souboru</th>";
  echo "<th>Šířka</th>";
  echo "<th>Výška</th>";
  echo "</tr>";

  if(!is_null($dirs)) {
    foreach($dirs as $i => $soubor) {
      ($i%2==0) ? $bgcolor = "#ddddee" : $bgcolor = "#ddddff";
      $path = $adr . "/" . $soubor;
      
      echo "<tr bgcolor=\"$bgcolor\"><td colspan=6>";
      if(basename($soubor) == "..") echo "<a href=\"".$_SERVER[PHP_SELF]."?action=list_dir&dir=".dirname($adr)."\">O úroveň výše</a>";
      else echo "<a href=\"?action=list_dir&dir=$path\">$soubor</a>";
      echo "</td></tr>";
    }
  }

  if(!is_null($files)) {
    foreach($files as $i => $soubor) {
      ($i%2==0) ? $bgcolor = "#dddddd" : $bgcolor = "#eeeeee";
      $path = $adr . "/" . $soubor;
      $href = $_SERVER[PHP_SELF]."?action=display_image&image=$path&adr=$adr&poradi=".($i+1)."&celkem=".count($files);
      
      echo "<tr bgcolor=\"$bgcolor\">";
      echo "<td><a href=\"$href\">" . $soubor . "</a></td>";
      echo "<td align=center><a href=\"$href\"><img src=\"$path\" width=\"50\" height=\"50\"></a></td>";
      echo "<td>" . date("H:i:s d.m.Y", filectime($path)) . "</td>";
      echo "<td>" . filesize($path) . " bajtů</td>";
      $imagesize = getimagesize($path);
      echo "<td>" . $imagesize[0] . " px</td>";
      echo "<td>" . $imagesize[1] . " px</td>";
      echo "</tr>";
    }
  }

  echo "</table>";
}

function display_image($image, $adr, $poradi = 0, $celkem = 0, $width = "100%", $height = "100%") {
  $jmeno = basename($image);
  $imagesize = getimagesize($image);
  
  // Obrázek
  
  echo "<a href=\"?action=list_dir&dir=$adr\"><img src=\"$image\" style=\"width:$width; height:$height;\" title=\"Zpět na seznam obrázků\"></a><br><br>";

  // Info o obrázku

  echo "<center><h1>$jmeno</h1></center>";
  echo "Velikost souboru: " . filesize($image), " bajtů<br>";
  echo "Čas poslední změny: " . date("H:i:s d.m.Y", filectime($image)), "<br>";
  echo "Šířka: " . $imagesize[0] . " px<br>";
  echo "Výška: " . $imagesize[1] . " px<br>";
  echo "Aktuální velikost: $width, $height<br>";
  echo "Pořadí v adresáři: $poradi. z $celkem<br>";
  
  echo "<br><br><center>";

  $files = get_picts($adr);
  $pocet = count($files);
  $href = $_SERVER[PHP_SELF]."?action=display_image&adr=$adr&celkem=".count($files);
  
  // Rotace

  echo "<a href=\"$href&poradi=$poradi&image=" . urlencode("trans_image.php?image=$image&action=rotateLeft") . "\">Otočit doleva</a> | ";
  echo "<a href=\"$href&poradi=$poradi&image=" . urlencode("trans_image.php?image=$image&action=rotateRight") . "\">Otočit doprava</a><br><br>";

  // Zvětšení / zmenšení

  if(endsWith($width, "%")) $aktualne = intval(substr($width, 0, 3));
  else $aktualne = 100;
  $bigger = $aktualne + 10;
  $smaller = $aktualne - 10;
  
  echo "<a href=\"$href&poradi=$poradi&image=$image&width=$bigger%&height=$bigger%\">+ Zvětšit</a> | ";
  echo "<a href=\"$href&poradi=$poradi&image=$image&width=100%&height=100%\">Na 100% obrazovky</a> | ";
  echo "<a href=\"$href&poradi=$poradi&image=$image&width=$imagesize[0]px&height=$imagesize[1]px\">1 : 1</a> | ";
  echo "<a href=\"$href&poradi=$poradi&image=$image&width=$smaller%&height=$smaller%\">- Zmenšit</a><br><br>";
  
  // Další / předchozí
  
  if($poradi != 1) {
    $path = $adr . "/" . $files[0];
    echo "<a href=\"$href&poradi=1&image=$path\">&lt;&lt;&lt;&lt; První obrázek</a> | ";

    $path = $adr . "/" . $files[$poradi-2];
    echo "<a href=\"$href&poradi=".($poradi-1)."&image=$path\">&lt;&lt; Předchozí obrázek</a> | ";
  }

  if($poradi != $celkem) {
    $path = $adr . "/" . $files[$poradi];
    echo "<a href=\"$href&poradi=".($poradi+1)."&image=$path\">Následující obrázek &gt;&gt;</a> | ";

    $path = $adr . "/" . $files[$pocet-1];
    echo "<a href=\"$href&poradi=$pocet&image=$path\">Poslední obrázek &gt;&gt;&gt;&gt;</a>";
  }
  
  echo "</center>";
}

?>
</body>
</html>